<?php

namespace Fufle\ORM;

use Fufle\Database\ConnectionManager;

abstract class Model {
    protected static string $primaryKey = 'id';
    protected static ?string $table = null;
    protected static ?IQuery $query = null;
    
    public function getTableName() {
        return static::$table;
    }
    
    public function getPrimaryKey() {
        return static::$primaryKey;
    }
    
    public static function Get(int $id) {
        return self::Query(
            static::$query->Get(),
            [$id]);
    }
    
    protected static function Query($sql, $params) {
        self::Check();
        return ConnectionManager::Query(
            $sql,
            $params,
            get_called_class());
    }
    
    protected static function QueryAll($sql, $params) {
        self::Check();
        return ConnectionManager::QueryAll(
            $sql,
            $params,
            get_called_class());
    }

    public static function Check() {
        if (static::$table === null) {
            static::$table = basename(get_called_class()) . 's';
        }
        static::Initialize();
    }
    
    abstract public static function Initialize();
}